<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted index access' );


/**
 * Renders a editors element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldAuth extends JFormField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	
	protected $type = 'auth';

	protected function getInput(){	}
	
	public function getLabel() {
		$label     = (string) $this->element['label'];
		
		ob_start(); ?>
		
		<p><a href="#" id="insta_auth_button" class="btn btn-primary">Get Access Token</a></p>
		<p class="auth-description zt-description">If you have filled the client id and redirect url fields below then clicking on the button above will generate the access token for you. Once the access token has been generated by Instagram copy the code fragment found in the popup window into the Instagram Access token field. For example, for a url like the following http://my-redirect-url.com#access_token=####. The access token is the collection of numbers after "access_token=".</p>
		
		<script>
			jQuery(document).ready(function($) {
				
				var access_token = $('input#jform_params_access_token').val();
				
				if(access_token !="") {
					$('.auth-description,#insta_auth_button').hide();
				}
				
				$(document).on('click', '#insta_auth_button', function() {
					
					var clientid = $('#jform_params_client_id').val();
					var redirect = $('#jform_params_redirect_url').val();
					
					if(clientid =="") {
						alert('Please enter your Instagram Client Id');
						return false;
					} 
					
					if(redirect =="") {
						alert('Please enter your Instagram Client Redirect Url');
						return false;
					} 
					
					//var url = 'https://api.instagram.com/oauth/authorize/?client_id='+ clientid +'&redirect_uri='+ redirect +'&response_type=token';
					var url = 'https://api.instagram.com/oauth/authorize/?client_id='+ clientid +'&redirect_uri='+ redirect +'&response_type=token';
					
					window.open (url,"mywindow","menubar=1,resizable=1,width=800,height=150");
				});
			});
		</script>
		
		<?php return ob_get_clean();

		
	}

}
?>