<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted index access' );
jimport('joomla.html.html');
jimport('joomla.form.formfield');

/**
 * Renders a editors element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldCompress extends JFormField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	
	protected $type = 'compress';

	protected function getInput()
	{
		
		
		
	}
	
	public function getLabel() {
		$label     = (string) $this->element['label'];
		$desc     = (string) $this->element['desc'];
		
		ob_start(); 
		
			// Get module id
			$id =  $_SERVER['REQUEST_URI'];
			
			// Split all up until the id fragment
			$id = explode('id=', $id);
			
			if(isset($id[1])) {
				// Make sure nothing comes after that
				$id = explode('&', $id[1]);
				
				// This is the id
				$id = $id[0];
			} else {
				$id = 0;
			}
			?>
			
			<p class="description"></p>
			<a href="#" class="uk-button uk-button-primary" id="zt-compress" data-action="compress">Compress scripts</a>
		
			<p>Files required by this instance of the module.</p>
			<ul id="files_required"></ul>
			
			<script>
			(function ($) {
				// Load Layout Function
				$(document).on('click', '#zt-compress', function() {
					
					var action = $(this).attr('data-action');
					var layout = $('#jform_params_layout').val();
					
					var url = '<?php echo JURI::base();?>../?option=com_ajax&plugin=zentools2&format=raw';
					var value   = layout,
						action  = action,
						request = {
								'option' : 'com_ajax',
								'plugin' : 'zentools2',
								'cmd'    : action,
								'data'   : value,
								'id'   : <?php echo $id;?>
							};
							
					$.ajax({
					 	url: url,
					 	method: 'get',
					 	context: document.body,
					 	type: 'POST',
					 	data   : request,
					 	
					 	beforeSend: function () {
					 			
					 		$('#zt-compress').text('Compressing javascript');
					 	},
					 		
					 	success: function (data) {
					 								 		
					 		$('#zt-compress').text('Javascript has been compressed!');
					 		
					 		
					 		setTimeout(function() {
					 			$('#zt-compress').text('Compress scripts');
					 		}, 3000);
					 	}
					});
				});
			})(jQuery);
			</script>
			
			
		<?php return ob_get_clean();
		
	}

}
?>