<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2014 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.13.2
 */

// no direct access
defined('_JEXEC') or die('Restricted access');


// Create a category selector
class JFormFieldGallery extends JFormField
{

	protected $type = 'Gallery';


	
	protected function getInput()
	{
		
		require_once __DIR__ . '/../includes/zentools2helper.php';
	
		
		// Instantiate the class
		$zen = new ZenTools2Helper();
		$target = $this->element['target'];
		$description = $this->element['description'];
		
		ob_start(); ?>
		
		<div class="zt-image-library">
			<h3>Image Library</h3>
			<p>Click on the folder names below to view available images. You can then drag these images into the gallery area on the right.</p>
			
			<!-- Image data gets loaded here via ajax-->
			
			<div id="folders">
					<ul></ul>
			</div>
				
			<div id="image-list"></div>
		</div>
		
		<div id="zt-image-gallery-container" class="zt-gallery-content">
			<h3>Drag images here.</h3>
			<p>Once an item is added to this list you can drag and drop to change their order.</p>
			<ul class="connectedSortable zt-image-gallery">
				<li class="disabled"></li>
			</ul>
		</div>
		
		<script>
			jQuery(document).ready(function($) {
				
				
				// Show all items
				$(document).on('click', '[data-id="edit"]', function() {
					$(this).toggleClass('open').parent().parent().parent().toggleClass('overview');
						$(document).getGalleryItems();
					return false;
				});
				
				
				// Remove Item
				$(document).on('click', '[data-id="remove"]', function() {
					$(this).parent().parent().parent().parent().remove();
					$(document).getGalleryItems();
					return false;
				});
				
				// Remove Item
				$(document).on('click', '[data-type="featured"]', function() {
					$(this).toggleClass('active');
					$(document).getGalleryItems();
					return false;
				});
				
				// Active classes for library buttons
				$('.library-button').on('click', function() {
					$('.library-button').removeClass('uk-button-primary');	
					$(this).addClass('uk-button-primary');
				
					return false;
				});
				
				// Make the first folder active
				$('#folders li:first-child a').addClass('uk-button-primary');
				
				
				// Display the images in the first folder
				var first_folder = $('#image-list ul:first').attr('data-folder');
				
				showimages(first_folder);
								
				// Show images on click
				$(document).on('click', '#folders a', function() {
					var target = $(this).parent().attr('data-folder');
					showimages(target);
				});
				
				function showimages(target) {
					
					$('#image-list ul').hide();
					
					$('#image-list ul[data-folder="' + target + '"] img').each(function() {
						var img = $(this).attr('data-src');
						$(this).attr('src', img );
					});
					
					$('#image-list ul[data-folder="' + target + '"]').fadeIn();
				}
				
				// Show all items
				$(document).on('blur', '.zt-gallery-item *', function() {
					$(document).getGalleryItems();
				});
				
				
				$(document).on('focus', '.zt-gallery-item input', function() {
					console.log('dd');
					$(document).getGalleryItems();
				});
				
								
				// Show all items
				$(document).on('click', '.zt-gallery-item *', function() {
					$(document).getGalleryItems();
				});
				
								
				$(window).load(function() {
					
					var items = $('#jform_params_gallery_settings').val();
					
					if(items !=="") {
							items = jQuery.parseJSON(items);
							items = items.images;
							
						$(items).each(function(i, item) {
							var exif = item.exif.replace(/\r?;/g, '\n');
							
							
							if(typeof item.paypal_link == "undefined") {
								item.paypal_link ="";
							}
							
							if(typeof item.embed_facebook == "undefined") {
								item.embed_facebook ="";
							}
							
							if(typeof item.embed_instagram == "undefined") {
								item.embed_instagram ="";
							}
							
							if(typeof item.embed_twitter == "undefined") {
								item.embed_twitter ="";
							}
							
							if(typeof item.video == "undefined") {
								item.video ="";
							}
							
							if(typeof item.embed_spotify == "undefined") {
								item.embed_spotify ="";
							}
							
							if(typeof item.embed_soundcloud == "undefined") {
								item.embed_soundcloud ="";
							}
							
							var item_content = '<li>' +
								'<div class="zt-gallery-item overview">' +
									'<div class="gallery-content-left">' +
										'<img class="zt-item" data-type="image" src="../'+ item.image+'"/>' +
										
										'<p class="toolbar">' +
											'<a data-id="remove" class="zt-icon remove-item" href="#none">' +
												'<span class="icon-remove"></span>' +
											'</a>';
									if(item.featured) {
										item_content +=	'<a href="#none" data-type="featured" class="active zt-icon zt-item zt-featured ">';
										} else {
										item_content +=	'<a href="#none" data-type="featured" class="zt-icon zt-item zt-featured ">';
										}
										item_content +=	'<span class="icon-heart"></span>' +
											'</a>' +
											'<a data-id="edit" href="#none" class="zt-icon edit">' +
												'<span class="icon-edit"></span>' +
											'</a>' +
											'<a href="#none" id="get_exif" data-action="get_exif" class="zt-icon get_exif">' +
												'<span class="icon-refresh"></span>' +
											'</a>' +
										'</p>' +
									'</div>' +
									'<div class="gallery-content-right">' +
										'<input class="zt-item" data-type="title" value="'+ item.title+'" placeholder="Title" />' +
										'<textarea class="fullview zt-item uk-form-large" data-type="introtext">'+ item.introtext+'</textarea>' +
										'<textarea class="fullview zt-item uk-form-large" data-type="fulltext">'+ item.fulltext+'</textarea>' +
										'<input class="fullview zt-item" data-type="author" value="'+ item.author+'" placeholder="Author" />' +
										'<input class="fullview zt-item" data-type="category" value="'+ item.category+'" placeholder="Category" />' +
										'<input class="fullview zt-item" data-type="date" value="'+ item.date+'" placeholder="Date" />' +
										'<input class="fullview zt-item" data-type="link_title" value="'+ item.link_title+'" placeholder="Link title" />' +
										'<input class="fullview zt-item" data-type="link" value="'+ item.link+'" placeholder="Link" />' +
										'<input class="fullview zt-item" data-type="video" value="'+ item.video+'" placeholder="Url to video" />' +
										'<input class="fullview zt-item" data-type="paypal_link" value="'+ item.paypal_link+'" placeholder="Paypal link" />' +
										'<input class="fullview zt-item" data-type="embed_facebook" value="'+ item.embed_facebook+'" placeholder="Facebook Embed url" />' +
										'<input class="fullview zt-item" data-type="embed_instagram" value="'+ item.embed_instagram+'" placeholder="Instagram Embed url" />' +
										'<input class="fullview zt-item" data-type="embed_twitter" value="'+ item.embed_twitter+'" placeholder="Twitter Embed url" />' +
										'<input class="fullview zt-item" data-type="embed_spotify" value="'+ item.embed_spotify+'" placeholder="Spotify Embed url" />' +
										'<input class="fullview zt-item" data-type="embed_soundcloud" value="'+ item.embed_soundcloud+'" placeholder="Soundcloud Embed url" />' +
										'<input class="fullview zt-item" data-type="tags" value="'+ item.tags+'" placeholder="Enter comma separated tags." />' +
										'<textarea data-id="exif_data" data-type="exif" data-name="exif" class="zt-item fullview">'+ exif+'</textarea>' +
									'</div>' +
								'</div>' +
								'<div class="clearfix"></div>' +
							'</li>';
							
							$('#zt-image-gallery-container ul').append(item_content);
						});
					}
				});
				
			});
			
			
			(function ($) {
				// Load Layout Function
				$(document).on('click', '#get_exif', function() {
					
					var action = $(this).attr('data-action');
					$(this).parent().parent().parent().addClass('seeking-exif')
					var image = $(this).parent().parent().find('img').attr('src');
					
					var url = '?option=com_ajax&plugin=zentools2&format=json';
					var value   = '',
						action  = action,
						request = {
								'option' : 'com_ajax',
								'plugin' : 'zentools2',
								'cmd'    : action,
								'data'   : image
							};
					
					$.ajax({
					 	url: url,
					 	method: 'get',
					 	context: document.body,
					 	type: 'POST',
					 	data   : request,
					 	
					 	beforeSend: function () {
					 			
					 		
					 	},
					 		
					 	success: function (data) {
					 		
					 		var data = data.data[0];
					 		
					 		$(data).each(function(index, item) {
					 			
					 			var make = item['make'];
					 			var model = item['model'];
					 			var author = item['author'];
					 			var copyright = item['copyright'];
					 			var date = item['date'];
					 			var exposure = item['exposure'];
					 			var f_stop = item['f_stop'];
					 			var focal_length = item['focal_length'];
					 			var introtext = item['introtext'];
					 			var iso = item['iso'];
					 			var shutter_speed = item['shutter_speed'];
					 			
					 			if(author !=="" && author !=="false") {
					 				$('.seeking-exif').find('[data-type="author"]').val(author);
					 			}
					 			if(copyright !=="" && copyright !=="false") {
					 			$('.seeking-exif').find('[data-type="copyright"]').val(copyright);
					 			}
					 			if(introtext !=="" && introtext !=="false") {
					 				$('.seeking-exif').find('[data-type="introtext"]').val(introtext);
					 			}
					 			if(date !=="" && date !=="false") {
					 				$('.seeking-exif').find('[data-type="date"]').val(date);
					 			}
					 			
					 			var exif_data = '';
					 			if(make !=="" && make !==false) {
					 				exif_data += "make:" + make + "\n";
					 			}
					 			if(model !=="" && model !==false) {
					 				exif_data += "model:" + model + "\n";
					 			}
					 			if(iso !=="" && iso !==false) {
					 				exif_data += "iso:" + iso + "\n";
					 			}
					 			if(exposure !=="" && exposure !==false) {
					 				exif_data += "exposure:" + exposure +  "\n";
					 			}
					 			if(f_stop !=="" && f_stop !==false) {
					 				exif_data += "f_stop:" + f_stop + "\n";
					 			}
					 			if(focal_length !=="" && focal_length !==false) {
					 				exif_data += "focal_length:" + focal_length + "\n";
					 			}
					 			if(shutter_speed !=="" && shutter_speed !==false) {
					 				exif_data += "shutter_speed:" + shutter_speed + "\n";
					 			}
					 			if(author !=="" && author !==false) {
					 				exif_data += "author:" + author +  "\n";
					 			}
					 			if(copyright !=="" && copyright !==false) {
					 				exif_data += "copyright:" + copyright + "\n";
					 			}
					 			
					 			$('.seeking-exif').find('textarea[data-id="exif_data"]').val(exif_data);
					 			
					 		});
					 		
					 		$('.zt-gallery-item').removeClass('seeking-exif');
					 	}
					});
				});
			})(jQuery);
			
			
		</script>
		<?php return ob_get_clean();
			
	}
}
