<?php defined('JPATH_PLATFORM') or die;

class JFormFieldZenmodulelayout extends JFormField
{

	public $type = 'ZenitemSettings';

	// icons

	protected function getInput()
	{
	
			// Displays the settings found in the layout xml for that specific layout
			// eg max-cols for grid, carousel speed for carousels.
			
			
			jimport('joomla.filesystem.folder');
			$path	= JPATH_ROOT.'/modules/mod_zentools2/settings/layouts/';
			
			$files = JFolder::files($path,'', false, false ); 
					
		?>
	
			<div id="zt-layout-settings" class="zt-admin hide">
				<h3 class="zt-title zt-toggler" id="zt-content-source">Module layout and settings   <span class="uk-badge uk-badge-notification hide">Edit module layout</span></h3>
				<div class="zt-toggle">
					
					<?php foreach ($files as $key => $layout)
					{  
					
						
						// Get the layouts available
						$layout = JFile::stripExt($layout); 
						$name = ucfirst(str_replace('-', ' ', $layout));
						
						// List layout items for this layout
						// eg navigation elements for carousel, slideshow etc 
						// 
						$items = JFactory::getXML($path . $layout . '.xml');
						
						?>
					<ul data-id="<?php echo $layout;?>-layout-settings" class="hide layout-settings">
						
						<?php 
							// Stores the settings applicable for that layout
							// eg grid max-cols or carousel autoplay
							// 
						?>
						<li>
							
								<?php foreach ($items->children()->group as $key => $items) { ?>
									
									<ul class="<?php echo $items['display'];?>">
									<?php foreach ($items as $key => $element) { 
									
									
										$type = $element['type'];
										$name = $element['name'];
										$label = $element['label'];
										$description = $element['description'];
										$default = $element['default'];
										$display = $element['display']; 
										$depend = $element['depend']; 
										
										if(isset($element['class'])) {
											$class = $element['class'];
										} else {
											$class="";
										}
										
										?>
										
									
										<li class="zt-settings-node" data-display="<?php echo $display;?>" data-value="<?php echo $default;?>" data-type="<?php echo $type;?>" data-name="<?php echo $name;?>">
											<?php 
												include(JPATH_ROOT . '/modules/mod_zentools2/fields/tags/' . $type . '.php');
											?>
										</li>
								
									<?php  } ?>
									</ul>
								<?php } ?>
							
						</li>
					</ul>
					<?php } ?>
				</div>
			</div>
	 <?php }
	
	function getLabel()
	{
		return '';
	}
}						