<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2014 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.13.2
 */

// no direct access
defined('_JEXEC') or die('Restricted access');


// Create a category selector
class JFormFieldZtlimit extends JFormField
{

	protected $type = 'Ztlimit';

	protected function getInput()
	{
		$target = $this->element['target'];
		$description = $this->element['description'];
		$class = $this->element['class'];
		
		ob_start();
		?>
		
			<div class="zt-limit-data <?php echo $class;?>" id="<?php echo $target;?>_limit">
			
			</div>
			<div class="clearfix"></div>
			<div class="zt-info <?php echo $class;?>">
			    <p><?php echo $description;?></p>
			</div>
			

			<script>
				jQuery(document).ready(function($) {
					
					
					// Set Limits
					limits();
					
					
					
					// Check when something has changed
					// Repopulate values
					$('#jform_params_<?php echo $target;?>').change(function() {
						
						limits();
						setlimits();
						
					});
					
					
					// Set limits for items
					$(document).on('blur', '#<?php echo $target;?>_limit input', function() {
						setlimits();
					});
					
					
					
					// Hide items
					$('.zt-limit-data.hide-item').parent().parent().hide();
					
					// Function that adds textbox and title for the items int he select that are selected
					function append_data(selectall) {
						
					
						$('#jform_params_<?php echo $target;?> option').each(function() {
							
							// Get the data from the selected items
							var name = $(this).text();
							var id = $(this).val();
							
							if(!selectall) {
								if($(this).attr('selected') && id !=="selectall") {
									$('#<?php echo $target;?>_limit').append('<div data-display="third"><h3>' + name + '</h3><input value="" data-cat="' + id + '" data-id="<?php echo $target;?>_limit_' + id + '" /></div>');
								} 
							} else {
								
								if(id !=="selectall") {
									
									$('#<?php echo $target;?>_limit').append('<div data-display="third"><h3>' + name + '</h3><input value="" data-cat="' + id + '" id="<?php echo $target;?>_limit_' + id + '" /></div>');
								}
							}
						});
					}
					
					
					
				
					
					function limits() { 
							// Null the limits
							$('#<?php echo $target;?>_limit').empty();
							
							var selectall = 0;
							
							if($("#jform_params_<?php echo $target;?> option").eq(0).attr('selected')) {
								selectall = 1;
							}
							
							// Appends the textbox etc 
							append_data(selectall);
							
							var set_limits = $('#jform_params_<?php echo $target;?>_limit').val()
							
							
							if(set_limits !=="") {
							
								if(typeof set_limits !=="undefined") {
							
									var set_limits = jQuery.parseJSON(set_limits);
								
										$.each(set_limits, function(cat, limit) {
										
											$('#<?php echo $target;?>_limit input[data-cat="' + cat +'"]').val(limit);
										});
								}
							}
						
					}
					
					
					function setlimits() {
						
						var data = '';
						
						// Set limits assigned
						$('#<?php echo $target;?>_limit input').each(function(i) {
							
				
							var value = $(this).val();
							var cat = $(this).attr('data-cat');
							
							if(i !== 0) {
								data += ',';
							}
						
							data += JSON.stringify(cat) + ':' + JSON.stringify(value) + '';
						});
						
						
						$('input#jform_params_<?php echo $target;?>_limit').val('{' + data + '}');
					}
				});
			</script>
			
		<?php
		
		return ob_get_clean();
			
	}
}
