<?php
/**
 * @version		$Id: helper.php 1832 2013-01-30 13:05:12Z lefteris.kavadas $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.net
 * @copyright	Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die;


class instagram
{

		/**
		 * Retrieve a list of article
		 *
		 * @param   JRegistry  &$params  module parameters
		 *
		 * @return  mixed
		 */
		public static function getList(&$params)
		{
		
		
			require_once __DIR__ . '/../includes/zentools2helper.php';
			
			// Instantiate the class
			$zen = new ZenTools2Helper();
			
			// Get the gallery content
			$instagramClientID = $params->get('client_id', '');
			$count = $params->get('instagram_count', '9');
			$access = $params->get('access_token', '');
			$query = $params->get('query', '');
			$cache_check = $params->get('instagram_cache_check', '80');
			$search_type = $params->get('instagram_search_type', '80');
			
			if($instagramClientID =="") {
				echo '<div class="alert alert-warning">Warning: Please enter the Instagram Client Id.</div>';
				return;
			}
			
			if($access =="") {
				echo '<div class="alert alert-warning">Warning: Please enter the access token for your Instagram client.</div>';
				return;
			}
			
			if($query =="") {
				echo '<div class="alert alert-warning">Warning: Please enter a user id.</div>';
				return;
			}
			
			
			// Create cache folder
			$cache_folder = JPATH_ROOT.'/cache/mod_zentools2-instagram/';
			if (!JFolder::exists($cache_folder))
			{
				JFolder::create($cache_folder);
			}
			
			$cached_response = $cache_folder.'/instagram-'.$query.'-'.$count.'.json';
			
			// Remove this later
			$search_type ="user";
			
			if($search_type =="user") {
				$api = 'https://api.instagram.com/v1/users/'.$query.'/media/recent/?access_token='.$access.'&scope=public_content';
			} else {
				$api = 'https://api.instagram.com/v1/tags/'.$query.'/media/recent/?access_token='.$access;
			}
						
			$instagram = self::get_content($cached_response,$api,$cache_check,$zen);
			
			if(isset($instagram->data)) {
				$instagram = $instagram->data;
			}
			else {
				echo '<div class="alert alert-warning">Warning: '.$instagram->meta->error_message.'</div>';
			}
			$settings = json_decode($params->get('layout_settings'));
			
			$resize_image = 0;
			
			foreach($settings as $key=>$colcontent) {
				
				foreach ($colcontent as $name =>$item_content) {
					if($name == 'image') {
						if(isset($item_content->resize)) {
			    			$resize_image = $item_content->resize;
			    		}
			    	 }
			    }
			}
			
			// Check if we have some images to process
			if (is_array($instagram))
			{
			
				
				
				//create an array of items for template
				// We copuld just grab the array but we may want to add items
				// later like get item from images meta data.
				
				$items = array();
				$i = 0;
				
				foreach ($instagram as $item)
				{
				
					if ($i >= $count) break;
					
					//print_r($item->images->standard_resolution->url);
					$item->image = $item->images->standard_resolution->url;
					
					// Store the image name
					if($resize_image) {
						$item->image = $zen->handleRemoteImage($item->image);
					}
					
					// Item Title
					if(isset($item->caption->text)) {
						$item->introtext = $item->caption->text;
					} else {
						$item->introtext = null;
					}
					
					
					// Item title used for image alt tags
					// Lets grab the image name since one doesnt exist in the endpoint
					$item->title = basename($item->images->standard_resolution->url);
					
					
					// Number of comments
					$item->comments = $item->comments->count;
					
					// Number of likes
					$item->likes = $item->likes->count;
					
					// user avatar and name
					$item->user_name = $item->user->username;
					$item->user_avatar = $item->user->profile_picture;
					
					
					// Location
					if(isset($item->location->street_address)) {
						$item->address = $item->location->street_address;
					} else {
						$item->address = null;
					}

					if(isset($item->location->latitude)) {
						$item->latitude = $item->location->latitude;
					} else {
						$item->latitude = null;
					}
					
					if(isset($item->location->longitude)) {
						$item->longitude = $item->location->longitude;
					} else {
						$item->longitude = null;
					}
					
					
				
					
					// Item key
					$item->key = $i;
												
					// Date
					if(isset($item->caption->created_time)) {
						$item->date = $item->caption->created_time;
					} else {
						$item->date = null;
					}
					
					// Author
					if(isset($item->caption->created_time)) {
						$item->author = $item->caption->from->full_name;
					} else {
						$item->author = null;
					}
					
					
					// Tags
					$tags = '';
					
					if(isset($item->tags)) {
						
						$taglist= array();
						
						foreach ($item->tags as $key => $tag) {
							
							$title = ltrim($tag, ' ');
							$title = rtrim($title, ' ');
							
							$alias = strtolower(str_replace(' ', '-', $title));
							
							$tagdata = array(
								'title' => $title,
								'link' => 'https://www.instagram.com/explore/tags/'.$title,
								'alias'=> $alias
							);
							
							$taglist[$alias] = (object)$tagdata;
							
							$item->tags = $taglist;
						}
						
					} else {
						
						$item->tags = null;
					
					}
					
					
					
					// Tags that should be nulled
					$item->featured = null;
					$item->catlink = "";
					$item->newlink = 0;
					$item->video =false;
					$item->authorLink=false;
					$item->avatar=false;
					$item->tagblock=false;
					$item->rating="";
					
					// Increment the count
					$i++;
					
					// Add all items to an array
					$items[] = $item;
				}
	
				// Return the items
				return $items;
			}
		}
		
		
		// Check to see if cached response exists
		/* gets the contents of a file if it exists, otherwise grabs and caches */
		private static function get_content($file,$url,$hours = 24,$zen) {
			//vars
			$current_time = time(); 
			$expire_time = $hours * 60 * 60; 
			
			$file_time = $current_time;
			
			if(file_exists($file)) {
			
				$file_time = filemtime($file);
			
				// check to see if file is older than the cache time
				if($current_time - $expire_time > $file_time) {
					// Get the content
					$content = $zen->get_curl($url);
					// Write the cache file
					file_put_contents($file,$content);
					//$content = self::write_spotify($file, $url);
					$content = json_decode($content);
					return $content;
					
				} else {
					// File is still fresh so get the contents
					$content = file_get_contents($file);
					$content = json_decode($content);
					return $content;
				}
			}
			else {
				// File doesnt exist so lets create it
				//$content = self::write_spotify($file, $url);
				// Get the content
				$content = $zen->get_curl($url);
				// Write the cache file
				file_put_contents($file,$content);
				
				$content = json_decode($content);
				return $content;
			}
		}
		
		
	}