<?php
/**
 * @version		$Id: helper.php 1832 2013-01-30 13:05:12Z lefteris.kavadas $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.net
 * @copyright	Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die;


class k2_authors
{

	public static function getList(&$params, $format = 'html')
	{

		$cats = json_decode($params->get('k2_categories_limit', ''));
		$order = $params->get('k2_authors_ordering', 'name DESC');	
		$count = $params->get('k2_authors_count', '5');
				
		
		// Cast object to an array
		$catitems = (array)$cats;
		
		// Get catids from array
		$catids = array_keys($catitems);
		
		// Count number of cats to process
		$limitcount = count($catitems);
		
		// Link Type
		$link_type = $params->get('k2_author_link_type', '0');
		
		
		// Get Contact items
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('a.*');
		
		if($order =='title') {
			
			$query->order('a.userName ASC');
			
		} elseif($order =='title_reverse') {
			
			$query->order('a.userName DESC');
			
		} elseif($order =='random') {
		
			$query->order('RAND()');
			
		} elseif($order =='order') {
		
			$query->order('a.id ASC');
		
		} elseif($order =='order_reverse') {
		
			$query->order('a.id DESC');
		
		} 
		
		$query->from('#__k2_users AS a'); 
		$db->setQuery($query, 0, $count);
		$authors = $db->loadObjectList();
		
		if(is_array($authors)) {
			foreach ($authors as $author)
			{
			
				// Create the new class
				$item = new stdClass();
										
				// Store the image name
				if(isset($author->image)) {
					$item->image = 'media/k2/users/' . $author->image;
				} else {
					$item->image = "";
				}
				
				// Item Title
				$item->title = $author->userName;
				$item->alias = strtolower(str_replace(' ', '-', $item->title));
				
				// Item Text
				$item->introtext = $author->description;
				
				$item->link = null;
				
				if($link_type && $author->url !=="") {
					$item->link = $author->url;
				} else {
					$item->link = "index.php?option=com_k2&view=itemlist&task=user&id=$author->userID:$item->alias";
				}
				
				
				$category = self::get_group($author->group);
				$item->category = $category[0]->name;
				$item->category_alias = strtolower(str_replace(' ', '-', $item->category));
				$item->url = $author->url;
				$item->catlink = "";
				
				// Tags that should be nulled
				$item->date = false;
				$item->created= false;
				$item->featured = 0;
				$item->newlink = 0;
				$item->text = false;
				//$item->$id = false;
				$item->video =false;
				$item->authorLink=false;
				$item->author=false;
				$item->avatar=false;
				$item->tagblock=false;
				$item->tags=false;
				$item->rating="";
				$item->fulltext = false;				
				
				// Add all items to an array
				$items[] = $item;
			}
			
			return $items;
		}
	}
	
	public static function get_group($id) {
		$db = JFactory::getDbo(); 
		$query = $db->getQuery(true); 
		$query->select(array('name')) 
		      ->from($db->quoteName('#__k2_user_groups')) 
		      ->setLimit(1)
			  ->where($db->quoteName('id') . ' = '. $id);
		$db->setQuery($query); 
		$rows = $db->loadObjectList();
		return $rows;
	}

}
