<?php
/**
 * @version		$Id: helper.php 1832 2013-01-30 13:05:12Z lefteris.kavadas $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.net
 * @copyright	Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die;


class zt_hikashop
{

	public static function getList(&$params, $format = 'html')
	{

				$cats = json_decode($params->get('hikashop_content_categories_limit', ''));
				//print_r($params->get('joomla_categories_categories_limit', ''));
				//$cats = json_decode('{"1":""}');
				$order = $params->get('hikashop_ordering', 'name DESC');	
				$count = $params->get('hikashop_count', '5');
				
				// Cast object to an array
				$catitems = (array)$cats;
				
				// Get catids from array
				$catids = array_keys($catitems);
				
				
			
				// Count number of cats to process
				$limitcount = count($catitems);
				
				
				// Get view access levels for current user id
				$user = JFactory::getUser();
				$viewLevels = JAccess::getAuthorisedViewLevels(JUserHelper::getUserId($user->username));
				$access_levels = implode(",", $viewLevels);	
				
				// Link Type
				$link_type = $params->get('hikashop_link_type', 'item');
				$link_fallback = $params->get('hikashop_link_fallback');
				
				// Fallback image
				$settings = json_decode($params->get('layout_settings'));
				$placeholder = 0;
				$placeholder_path = "";
				
				
				$get_price = 0;
				$get_image = 0;
				$get_brand = 0;
				
				foreach($settings as $key=>$colcontent) {
				
					foreach ($colcontent as $name =>$item_content) {
									    	
				    	if($name == 'image') {
				    		if(isset($item_content->placeholder)) {
				    			$placeholder = $item_content->placeholder;
				    			$placeholder_path = $item_content->placeholder_path;	
				    		}
				    		
				    		$get_image = 1;
				    	}
				    	
				    	if($name == 'price') {
				    		$get_price = 1;
				    	}
				    	
				    	if($name == 'images') {
				    		$get_image = 1;
				    	}
				    	
				    	if($name == 'brand') {
				    		$get_brand = 1;
				    	}
				    }
				}
				
				// Manual Links
				$manual_links = null;
				
				if($link_type =="manual") {
					$manual_links = explode(PHP_EOL, $params->get('hikashop_manual_links'));
				}
				
	
				if($params->get('hikashop_content_type') =="items") {
				
					$id = $params->get('hikashop_content_items', '');
					
					if(!$id) {
						return;
					}
					
					$db = JFactory::getDBO();
					$query	= $db->getQuery(true);
					$query->select('*')
					    ->from('#__hikashop_product')
					    ->where('product_id in ('.implode(',', $id).')');
					
					
					if($order =='title') {
						
						$query->order('product_name ASC');
						
					} elseif($order =='title_reverse') {
						
						$query->order('product_name DESC');
						
					} elseif($order =='random') {
					
						$query->order('RAND()');
						
					} elseif($order =='code') {
					
						$query->order('product_code ASC');
					
					} elseif($order =='code_reverse') {
					
						$query->order('product_code DESC');
					
					} elseif($order =='created') {
					
						$query->order('product_created ASC');
					
					} elseif($order =='created_reverse') {
					
						$query->order('product_created DESC');
					} 
					elseif($order =='sales') {
					
						$query->order('product_sales ASC');
					
					} elseif($order =='sales_reverse') {
					
						$query->order('product_sales DESC');
					} 
					elseif($order =='votes') {
					
						$query->order('product_total_vote ASC');
					
					} elseif($order =='votes_reverse') {
					
						$query->order('product_total_vote DESC');
					} 
					
					
					$db->setQuery($query, 0, $count);
					$products = $db->loadObjectList();
					   
				
				} else {
				
					if(empty($catids)) {
						echo '<div class="alert alert-warning">Please select some categories or items to display.</div>';
						return;
					}
								
					// If just a single value then proceed as usual
					if($limitcount <= 1) {
						
						
						// Get all products from a specified category
						$db = JFactory::getDBO();
						$query	= $db->getQuery(true);
						$query->select('product_id');
						$query->from($db->quoteName('#__hikashop_product_category')); 
						$query->where($db->quoteName('category_id') .' in (' . implode(',', $catids).')');
						$db->setQuery($query, 0);
						$get_products = $db->loadColumn();
						
						// If no limits on category numbers we just perform the standard query
						$db = JFactory::getDBO();
						$query	= $db->getQuery(true);
						$query->select('a.*');
						$query->from('#__hikashop_product AS a'); 
						
						if(!empty($get_products)) {
							$query->where('a.product_id in(' . implode(',', $get_products).')');
						    $query->where('a.product_published = 1');
						}
						
						//$query->where('product_published = 1')->where("product_access in ($access_levels)");
						
						if(isset($catids[0])) {
							
							$limit = $cats->{$catids[0]};
							
							if($limit > $count || $limit == "") {
								$limit = $count;
							}
							
						} else {
							$limit = $count;
						}
						
						if($order =='title') {
							
							$query->order('product_name ASC');
							
						} elseif($order =='title_reverse') {
							
							$query->order('product_name DESC');
							
						} elseif($order =='random') {
						
							$query->order('RAND()');
							
						} elseif($order =='code') {
						
							$query->order('product_code ASC');
						
						} elseif($order =='code_reverse') {
						
							$query->order('product_code DESC');
						
						} elseif($order =='created') {
						
							$query->order('product_created ASC');
						
						} elseif($order =='created_reverse') {
						
							$query->order('product_created DESC');
						} 
						elseif($order =='sales') {
						
							$query->order('product_sales ASC');
						
						} elseif($order =='sales_reverse') {
						
							$query->order('product_sales DESC');
						} 
						elseif($order =='votes') {
						
							$query->order('product_total_vote ASC');
						
						} elseif($order =='votes_reverse') {
						
							$query->order('product_total_vote DESC');
						} 
			
					
						$db->setQuery($query, 0, $limit);
						$products = $db->loadObjectList();
						
					} else {
					
						// Get items from each category limited by number set in admin
						// To do this we need to union the selects
						// and then apply an order at the end
						
						$db = JFactory::getDbo();
						$query = $db->getQuery(true);
						
						// Loops through the catd ids and limits set
						// catid:limit
						// 42:2
					
						// We need to calculate the new total items to display
						// Check later to see if it's higher or lower than the count amount
						$total = '';
				
						
						// Get all of the product ids first
						foreach ($cats as $catid => $limit) {
						
							// If limit is left blank in the settings
							if($limit == "") {
								$limit = $count;
							}
							
							// Set up the union query
							${'q'.$catid} = $db->getQuery(true);
							
							${'q'.$catid}
							    ->select('product_id')
							    ->from('#__hikashop_product_category')
							    ->where('category_id = '.$catid);
							   
							   // Limit the items from this category
							   ${'q'.$catid}->setLimit($limit);
							    
							   $total += $limit;
						}
					
						
						
						// Create the union query
						$query
						    ->select('product_id')
						    ->from('#__hikashop_product_category')
						    ->where('1 = 0');
						    
						 foreach ($cats as $catid => $limit) {
						   	$query->union(${'q'.$catid});
						 }
						 
						 
						 // Remove the limit that gets set and inherited from the last
						 // item in the loop of union selects
						 // $query = str_replace('LIMIT 0, '.$limit, '', $query);
						  
						 // If the total number of items is less than the count
						 if($total < $count) {
						  	$query .= ' LIMIT 0, ' . $total ;
						 } else {
						  	$query .= ' LIMIT 0, ' . $count ;
						 }
						  
						 $db->setQuery($query);	
						 	
						 // The final array of product ids   	    	    
						 $get_products = $db->setQuery($query)->loadColumn();	
						
						
						// Now go and get the product data
						$db = JFactory::getDBO();
						$query	= $db->getQuery(true);
						$query->select('a.*');
						$query->from('#__hikashop_product AS a'); 
						
						if(!empty($catids)) {
							$query->where('a.product_id in(' . implode(',', $get_products).')');
						    $query->where('a.product_published = 1');
						}
						
						//$query->where('product_published = 1')->where("product_access in ($access_levels)");
						
						
						
						if($order =='title') {
							
							$query->order('product_name ASC');
							
						} elseif($order =='title_reverse') {
							
							$query->order('product_name DESC');
							
						} elseif($order =='random') {
						
							$query->order('RAND()');
							
						} elseif($order =='code') {
						
							$query->order('product_code ASC');
						
						} elseif($order =='code_reverse') {
						
							$query->order('product_code DESC');
						
						} elseif($order =='created') {
						
							$query->order('product_created ASC');
						
						} elseif($order =='created_reverse') {
						
							$query->order('product_created DESC');
						} 
						elseif($order =='sales') {
						
							$query->order('product_sales ASC');
						
						} elseif($order =='sales_reverse') {
						
							$query->order('product_sales DESC');
						} 
						elseif($order =='votes') {
						
							$query->order('product_total_vote ASC');
						
						} elseif($order =='votes_reverse') {
						
							$query->order('product_total_vote DESC');
						} 
			
						$db->setQuery($query, 0, $count);
						$products = $db->loadObjectList();
						
					}
				}
				
			
				
				if(!empty($products)) {
				
					$items = array();
					
					foreach ($products as $key=>$product) {
					
						// Create the new class
						$item = new stdClass();
					
						// Title
						$item->title = $product->product_name;
						$item->alias = str_replace(' ', '-', $item->title);
						
						// Description
						$item->introtext = $product->product_description;
						
						// Images
						if($get_image) {
							$item->images = self::get_images($product->product_id);
							
							// First image
							if(isset($item->images{0}->file_path)) {
								if(file_exists('media/com_hikashop/upload/' . $item->images{0}->file_path)) {
									$item->image = 'media/com_hikashop/upload/' . $item->images{0}->file_path;
								} else {
									$item->image = 'images/com_hikashop/upload/' . $item->images{0}->file_path;
								}
							} else {
								$item->image = "";
							}
							if($item->image == "") {
								if($placeholder) {
									$item->image = $placeholder_path;
								} else {
									$item->image = "";
								}
							}
							
							// Get all images
							$images = array();
							
							foreach ($item->images as $image) {
							
								
								if(file_exists('media/com_hikashop/upload/' .  $image->file_path)) {
									$images[] = 'media/com_hikashop/upload/' .  $image->file_path;
								} else {
									$images[] = 'images/com_hikashop/upload/' .  $image->file_path;
								}
								
							}
							
							$item->images = $images;
						} else {
							$item->images = null;
							$item->image = null;
						}
						
						if($link_type =="manual") {
							
								
							if(isset($manual_links[$key])) {
								$item->link = $manual_links[$key];
								
							}  else {
								if($link_fallback) {
										$item->link = 'index.php?option=com_hikashop&ctrl=product&task=show&cid='.$product->product_id.'&name='.$item->alias;
									} else {
										$item->link = null;
									}
							}
						} else {
							
							$item->link = 'index.php?option=com_hikashop&ctrl=product&task=show&cid='.$product->product_id.'&name='.$item->alias;
							
						}
						
										
						// Quantity
						$item->quantity = $product->product_quantity;
						$item->weight = $product->product_weight;
						$item->height = $product->product_height;
						$item->width = $product->product_width;
						$item->length = $product->product_length;
						$item->number_sales = $product->product_quantity;
						$item->code = $product->product_code;
						$item->date = $product->product_created;
						
						$item->contact = $product->product_contact;
						$item->manufacturer = $product->product_manufacturer_id;
						
						// Brand
						if($get_brand) {
							if($product->product_manufacturer_id) {
								$item->brand = self::get_category($product->product_manufacturer_id);
								$item->brand_url = 'index.php?option=com_hikashop&ctrl=category&task=listing&cid='.$product->product_manufacturer_id.'&name='.$item->brand[0]->category_alias.'&Itemid=266';
							} else {
								$item->brand = 0;
							}
						} else {
							$item->brand = 0;
						}
						
						// Price
						if($get_price) {
							$item->price = self::get_price($product->product_id);
							
							if(isset($item->price[0]->price_currency_id)) {
								$item->currency = $item->price[0]->price_currency_id;
								$currency = self::get_currency($item->currency);
								$item->currency = $currency[0]->currency_symbol;
							} else {
								$item->currency = '$';
							}
							
							if(isset($item->price[0]->price_value)) {
								$item->price = $item->price[0]->price_value;
							} else {
								$item->price = "";
							}
							
							$item->retail_price = $product->product_msrp;
							
						} else {
							$item->currency = 0;
							$item->price = null;
							$item->retail_price = null;
						}
						
						
						
						
						// Url
						$item->url = $product->product_url;
						
						// Category
						$item->category = self::get_category_id($product->product_id);
						$category = self::get_category($item->category[0]->category_id);
						$item->category = $category[0]->category_name;
						$item->catid = $category[0]->category_id;
						$item->catalias = $category[0]->category_alias;
						$item->category_alias = $item->catalias;
						$item->catlink = 'index.php?option=com_hikashop&ctrl=category&task=listing&cid='.$item->catid.'&name='.$item->catalias.'&Itemid=266';
				
						
						$item->keywords = $product->product_keywords;
						$item->number_sales = $product->product_sales;
						
						// Meta
						$item->metadescription = $product->product_meta_description;
						
						// Featured
						$item->featured = null;
						
						$item->video_url="";
						
						$items[] = $item;
					}
					return $items;
				}
				
			}
			
		
			
			
			public static function get_images($product_id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('file_path', 'file_ordering')) 
				      ->from($db->quoteName('#__hikashop_file'))
					  ->where($db->quoteName('file_ref_id') . ' = '. $product_id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
		
			
			
			public static function get_category($parent_id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('category_id','category_name', 'category_alias')) 
				      ->from($db->quoteName('#__hikashop_category')) 
				      ->setLimit(1)
					  ->where($db->quoteName('category_id') . ' = '. $parent_id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
			
			public static function get_category_id($id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('category_id')) 
				      ->from($db->quoteName('#__hikashop_product_category')) 
				      ->setLimit(1)
					  ->where($db->quoteName('product_id') . ' = '. $id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
			
			public static function get_price($id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('price_value','price_currency_id')) 
				      ->from($db->quoteName('#__hikashop_price')) 
				      ->setLimit(1)
					  ->where($db->quoteName('price_id') . ' = '. $id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
			
			public static function get_currency($currency_id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('currency_code', 'currency_symbol')) 
				      ->from($db->quoteName('#__hikashop_currency'))
					  ->where($db->quoteName('currency_id') . ' = '. $currency_id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
		

}
