/*!
 * Lightbox script for Magnific for Zentools2
 * 
 */
 
(function ($) {
		
	$.fn.zt_lightbox = function (id,element, gallery_enable, title, close, counter, description, twitter, facebook, pinterest, gplus, base, twitter_user) {
	
			var lightbox_markup = '<div class="mfp-figure">'+
					'<figure>'+
						'<header class="mfp-header">'+
							'<div class="mfp-top-bar">';
			
						if(title || twitter || facebook || pinterest || gplus) {
							lightbox_markup += '<div class="mfp-title"></div>';
						}		
						
						if(close) {
							lightbox_markup +=	'<div class="mfp-close"></div>';
						}
						
						lightbox_markup +=	'<div class="mfp-decoration"></div>'+
							'</div>'+
						'</header>'+
						'<section class="mfp-content-container">'+
							'<div class="mfp-img"></div>'+
						'</section>'+
						'<footer class="mfp-footer">'+
							'<figcaption class="mfp-figcaption">'+
								'<div class="mfp-bottom-bar-container">'+
									'<div class="mfp-bottom-bar">';
										
										if(counter) {
											lightbox_markup +=	'<div class="mfp-counter"></div>';
										}
										
										if(description) {
											lightbox_markup +=	'<div class="mfp-description"></div>';
										}
										
										lightbox_markup +='<div class="mfp-decoration"></div>'+
									'</div>'+
								'</div>'+
							'</figcaption>'+
						'</footer>'+
					'</figure>'+
			'</div>';
			
			$(element).magnificPopup({
				delegate: 'a.zt-lightbox',
				  type: 'image',
				  removalDelay: 500, //delay removal by X to allow out-animation
				  tLoading: '',
				
								 gallery: {
				 	enabled: gallery_enable,
				  	navigateByImgClick: true,
				  	preload: [0,1] // Will preload 0 - before current, and 1 after the current image
				  },
				  image:
			  		{
			  			headerFit: true,
			  			captionFit: true,
			  			preserveHeaderAndCaptionWidth: false,
			  			markup: lightbox_markup,
			  			titleSrc: function(item)
			  			{
			  				if(title) {
                            		var caption = item.el.attr('title');
                                } else {
                            		var caption = '&nbsp;';
                                }
                                
			  				var display = "<div class='zt-lightbox-social'>";
			  				
	                        if(gplus) {
							 display += '<div class="g-plusone" data-size="medium" data-href="' + item.el.attr('href') + '"></div>';
							 						 
							  display += "<script type='text/javascript'>(function() {var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;po.src = 'https://apis.google.com/js/platform.js';var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);})();<\/script>";
							  
							 }
							 
							 if(twitter) { 
							  $.ajax({ url: 'http://platform.twitter.com/widgets.js', dataType: 'script', cache:true});
							 								  
							  display += '<div><a href="https://twitter.com/share" data-url="' + window.location.href + '" class="twitter-share-button"   data-via="' + twitter_user +'" data-text="' + item.el.attr('title') +'">Tweet</a></div><script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?"http":"https";if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+"://platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document, "script", "twitter-wjs");</script>';
							  
							 }
							 
							 if(pinterest) {
							 	var pinItURL = "http://pinterest.com/pin/create/button/";
							 	pinItURL += '?url=' +  window.location.href;
							 	pinItURL += '&media='+ base + item.el.attr('href');
							 	pinItURL += '&description=' + item.el.attr('title');
							 	display += '<a class="pin-it" href="'+pinItURL+'" target="_blank"><img src="http://assets.pinterest.com/images/pidgets/pin_it_button.png" /></a>';
							 }
							 	
							 if(facebook) {
							 display += '<div class="fb-like" data-href="' + item.el.attr('href') + '" data-layout="button_count" data-width="450px" data-action="like" data-show-faces="true" data-share="true"></div><script>try{FB.XFBML.parse();}catch(ex){};</script>';
							  }
							 
							  
							return caption + display;
			  			},
			  			descriptionSrc: function(template, values, item)
			  			{
			  				
			  				values.description = item.el.data('description'); // or item.img.data('description');
			  				$('.mfp-description').text(values.description);
			  			}
			  		},
				  callbacks: {
				      beforeOpen: function() {
				        // just a hack that adds mfp-anim class to markup 
				         this.st.image.markup = this.st.image.markup.replace('mfp-figure', 'mfp-figure mfp-with-anim');
				         
				         var target = this.st.el.attr('data-target');
				         var effect = this.st.el.attr('data-effect')
				         this.st.mainClass = target + ' ' + effect;
				         
				       
				      },
				    
				      change: function() {
				              if (this.isOpen) {
				                  this.wrap.addClass('mfp-open');
				              }
				              
				          },
				      markupParse: function(template, values, item)
				      {
				      	
				      	values.description = item.el.data('description'); // or item.img.data('description');
				      	$('.mfp-description').text(values.description);
				      },
				      imageLoadComplete: function() {
				            var self = this;
				            setTimeout(function() {
				              self.wrap.addClass('mfp-image-loaded');
				            }, 16);
				          },
				          close: function() {
				            this.wrap.removeClass('mfp-image-loaded');
				          }
			    },
				  closeOnContentClick: true,
				  midClick: true // allow opening popup on middle mouse click. Always set it to true if you don't provide alternative source.
			});
			
			try{
					    FB.XFBML.parse(); 
					}catch(ex){}
		};
		
		
})(jQuery);