<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 

$class = ' '.$options->effect;

if($options->margin) {
	$class .= ' zt-no-margin';
}
$class .= ' max-cols-'.$options->maxcols;

if($options->imagesloaded) {
	$class .= ' wait-for-images';
}

// Create image element
$image = $layout->{0}->image;
$count = count((array)$layout->{0});


?>

<div id="zentools-<?php echo $module->id;?>" class="zentools zt-caption zt-grid <?php echo $class;?>">

	<?php if($options->imagesloaded) {  $zen->loadBlock('loader', $module, $options); } ?>
	
	<ul>
		<?php foreach ($list as $key => $item) { 
		
			$item_class = '';
			if($item->featured) {
				$item_class .= ' zt-featured';
			}
			
			?>
			<li grid-col="1/<?php echo $options->maxcols;?>" class="zt-item<?php echo $item_class;?> zt-item-<?php echo $key + 1;?>">
				<figure>
					<?php $settings->count = '0';$zen->loadElement('image', $image, $item, $settings, $zen);?>
					<?php if($count > 1) { ?>
					<figcaption>
					<?php foreach ($columns as $column => $colwidth) { ?>
						<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
							<?php $elements = $layout->$column;
								foreach ($elements as $type => $element) {
									$settings->count = $count;
									if($type !=="image") {
										$zen->loadElement($element->type, $element, $item, $settings, $zen);
									}
								} ?>
							</div>
					<?php } ?>	
					</figcaption>
					<?php } ?>
				</figure>
			</li>
		<?php } ?>
	</ul>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<?php if($options->imagesloaded) { ?>
<script>
jQuery(document).ready(function($) {
	$('#zentools-<?php echo $module->id;?>.wait-for-images').imagesLoaded( function() {
	  	$('#zentools-<?php echo $module->id;?> .loading-wrap').fadeOut("normal", function() {
	  		
	  		$('#zentools-<?php echo $module->id;?>.wait-for-images img').each(function() {
	  			var image = $(this).attr('data-src');
	  			$(this).attr('src', image);
	  		});
	  		
	  		$('#zentools-<?php echo $module->id;?>').removeClass('wait-for-images');
	  		$('#zentools-<?php echo $module->id;?> li.zt-item').fadeIn();	  		
	 	});
	 });
	 
	 
	 // Simulate hover for touch
	 $('#zentools-<?php echo $module->id;?> li.zt-item').bind('touchstart touchend', function(e) {
	         $(this).find('figure').toggleClass('caption-hover');
	 });
});
</script>
<?php } ?>