<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 

$class = ' zt-'.$options->theme;

// Load Matchheights
$match_height = "";

if($options->matchheight) { 
	$doc->addScript($media_path .'js/jquery.matchHeight-min.js');
	$match_height = 'data-match-height="zt-match-height"';
} 

// Disable / enable drag events
$mouse_drag = 1;
if(isset($options->mouse_drag)) {
	$mouse_drag = $options->mouse_drag;
}

$touch_drag = 1;
if(isset($options->touch_drag)) {
	$touch_drag = $options->touch_drag;
}
?>

<div id="zentools-<?php echo $module->id;?>" class="zentools owl-carousel carousel-featured <?php echo $class;?>">
	
	<!-- dummy element to make sure carousel will allow the first item to be featured -->
	<div>&nbsp;</div>
	
	<?php foreach ($list as $key => $item) { 
	
	$item_class = '';
	if($item->featured) {
		$item_class .= ' zt-featured';
	}
	
	?>
		<div>
			<div class="zt-item<?php echo $item_class;?> zt-item-<?php echo $key + 1;?>">
				<?php foreach ($columns as $column => $colwidth) { ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
						<?php $elements = $layout->$column;
							$count = 1;
							$total_elements = count((array)$elements);
							
							foreach ($elements as $type => $element) {
								
								$settings->count = $count;
								
								if($count == 2) { ?>
									<div class="zt-item-container" <?php echo $match_height;?>>
								<?php }
								
								$zen->loadElement($element->type, $element, $item, $settings, $zen);
								
								if($count == $total_elements && $count !==1) { ?>
									</div>
								<?php } 
								$count ++;
							} ?>
						</div>
				<?php } ?>	
			</div>
		</div>
	<?php } ?>
	<div>&nbsp;</div>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<script>
	jQuery(document).ready(function($) {
	 	$("#zentools-<?php echo $module->id;?>").owlCarousel({
		  	items: "3",
		  	itemsDesktop : [1200,3], //5 items between 1000px and 901px
	  	    itemsDesktopSmall : [800,3], // betweem 900px and 601px
	  	    itemsTablet: [700,3], //2 items between 600 and 0
	  	    itemsMobile : [600,1],
	  	    lazyLoad : true,
	  	    stopOnHover: true,
	  	    <?php if(!$mouse_drag) { ?>
	  	     	mouseDrag: false,
	  	     <?php } ?>
	  	     <?php if(!$touch_drag) { ?>
	  	      	touchDrag: false,
	  	      <?php } ?>
	  	    slideSpeed : <?php echo $options->slide_speed;?>,
	  	    paginationSpeed : <?php echo $options->slide_speed;?>,
	  	    <?php if($options->autoplay) { ?>
	  	    autoPlay : <?php echo $options->autoplay_speed;?>,
	  	    <?php } ?>
	  	    pagination: false,	  	        
	  	    <?php if($options->navigation) { ?>
	  	      navigation: true,
	  	      navigationText: ["<?php echo $options->nav_prev;?>","<?php echo $options->nav_next;?>"],
	  	      <?php } ?>
	  	    scrollPerPage: false,
	  	   
	  	   afterInit: function(el) {
	  	   		this.goTo(1)
	  	   },
	  	   	  	   
	  	   afterAction: function(el){
	  	          //remove class active
	  	          this
	  	          .$owlItems
	  	          .removeClass('active')
	  	         
	  	         
	  	         
	  	          //add class active
	  	          this
	  	          .$owlItems //owl internal $ object containing items
	  	          .eq(this.currentItem + 1)
	  	          .addClass('active');
	  	         
	  	         
	  	   }
  	  });
  	  
	});
</script>