<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 

if(is_array($item->extrafields)) {

	$delimiter = ":";
	
	if(isset($element->extra_fields_delimiter)) {
		$delimiter = $element->extra_fields_delimiter;
	}
	
	$show_label = 0;
	
	if(isset($element->show_label)) {
		$show_label = $element->show_label;
	}
	
	$title_class = "strong";
	
	if(isset($element->field_title_class)) {
		$title_class = $element->field_title_class;
	}
	
	
	if($element->hide_fields !=="") {
		
		// Ids to hide
		$hide_items = explode(',', $element->hide_fields);
		
		foreach ($item->extrafields as $key => $field) {
			if(in_array($field->id, $hide_items)) {
				unset($item->extrafields[$key]);
			}
		}
	}
	
	if(!empty($item->extrafields)) {
	
	if(!isset($element->alignment)) {
		$element->alignment = "left";
	} 
	
	$responsive_class = $zen->responsive_classes($element->responsive_classes); 
	?>
	
	<div class="zt-extra-fields zt-element zt-<?php echo $element->display;?> zt-element-<?php echo $settings->count;?> zt-<?php echo $element->alignment;?> <?php echo $responsive_class;?>">
		<?php if($element->extra_fields_title !=="") { ?>
			<h3><?php echo $element->extra_fields_title;?></h3>
		<?php } ?>
		<ul>
			<?php foreach($item->extrafields as $field) {?>
					<li class="zt-extra-field" id="zt-field-<?php echo htmlspecialchars(str_replace(' ', '-', $field->name));?>">
						<?php if($show_label) { ?>
							<<?php echo $title_class;?>>
								<?php echo $field->name;?>
							</<?php echo $title_class;?>> <?php echo $delimiter;?> <?php } ?><?php echo $field->value;?>
					</li>
			<?php } ?>
		</ul>
	</div>
<?php } 
	}
?>