<?php
/**
 * @package		Zen Tools 2
 * @subpackage	Zen Tools 2
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2015 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.0.5
 */

defined('_JEXEC') or die('Restricted access'); 


$title_exists = null;
$image_exists = null;
$link_type = 0;


foreach($layout as $key=>$colcontents) {
	
	foreach($colcontents as $colcontent) {
   
   		if($colcontent->type == 'title') {
   		
	    	$title_exists = 1;
	    	$link_type = $colcontent->link;
	    }
	    
	    if($colcontent->type == 'image') {
	    	if($link_type !=="2") {
	    		$link_type = $colcontent->link;
	    	}
	    	$image_exists = 1;
	    }
	    
	   
	    if($colcontent->type == 'readmore') {
	    
	    	if($link_type !=="2") {
	    		$link_type = $colcontent->link;
	    	}
	    }
    }
}


if($image_exists || $title_exists) {

	if($link_type !== "2") {
		
		if($settings->debug) {
			echo '<div class="alert alert-warning">';
			echo JText::_('MOD_ZENTOOLS2_LIGHTBOX_REQUIRED');
			echo '</div>';
		}
		
		if(!$lightbox->enable) {
			$doc  = JFactory::getDocument();
			$doc->addScript($media_path . 'js/lightbox/magnific.js');
			$doc->addScript($media_path . 'js/lightbox/lightbox-min.js');
		}
	}
	
	
?>

<div id="zentools-<?php echo $module->id;?>" class="zentools zt-grid zt-responsive-grid  zt-single">
	<ul>
		<?php foreach ($list as $key => $item) { 
		
		if($key == "0") {
		?>
			<li grid-col="1/1" class="zt-item zt-item-<?php echo $key + 1;?>">
				<?php foreach ($columns as $column => $colwidth) { ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?>"> 
						<?php $elements = $layout->$column;
							$count = 0;
							$total_elements = count((array)$elements);
							
							foreach ($elements as $type => $element) {
								
								$settings->count = $count;
								
								if($count == 1) { ?>
									<div class="zt-item-container">
								<?php }
								
								$zen->loadElement($element->type, $element, $item, $settings, $zen);
								
								if($count == $total_elements) { ?>
									</div>
								<?php } 
								$count ++;
							} ?>
						</div>
				<?php } ?>	
			</li>
		<?php } 
		}?>
	</ul>
</div>

<script>
jQuery(document).ready(function($) {

	// Example with multiple objects
	$('#zentools-<?php echo $module->id;?> .zt-lightbox').magnificPopup({
	    
	    items: [
	    
	    	<?php foreach ($list as $key => $item) { 
	    	
	    		if($item->image!=="") {
	    		
	    		if($source == "spotify") {
	    			$item->image = $zen->handleRemoteImage($item->image);
	    		}
	    		?>
	    	{
	    		  src: '<?php echo JURI::base() . $item->image;?>'
	    	},
	    	<?php } 
	    	}?>
	    ],
	    gallery: {
	      enabled: true,
	      navigateByImgClick: true,
	      	preload: [0,1] // Will preload 0 - before current, and 1 after the current image
	    },
	    type: 'image',
	    
	    callbacks: {
	          beforeOpen: function() {
	            // just a hack that adds mfp-anim class to markup 
	             this.st.image.markup = this.st.image.markup.replace('mfp-figure', 'mfp-figure mfp-with-anim');
	             target = this.st.el.attr('data-target');
	             effect = this.st.el.attr('data-effect')
	             this.st.mainClass = target + ' ' + effect;
	          },
	        
	          change: function() {
	                  if (this.isOpen) {
	                      this.wrap.addClass('mfp-open');
	                  }
	          },
	        
	          imageLoadComplete: function() {
	                var self = this;
	                setTimeout(function() {
	                  self.wrap.addClass('mfp-image-loaded');
	                }, 16);
	              },
	              close: function() {
	                this.wrap.removeClass('mfp-image-loaded');
	              },
	    },
	      closeOnContentClick: true,
	      midClick: true // allow opening popup on middle mouse click. Always set it to true if you don't provide alternative source.
	});
});
</script>
<?php } else { ?>
<p class="alert alert-warning">This layout requires either the title or image tag to be displayed in the module. Go the module settings for this module and add the title or image to the item layout area.</p>
<?php } ?>