<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 


// Load Carousel
$doc->addScript($media_path .'js/backstretch.js');

$height = str_replace('px', '', $options->backstretch_height);

$image = "";

if(isset($layout->{0}->image)) {
	$image = $layout->{0}->image;
} elseif(isset($layout->{0}->fulltext_image)) {
	$image = $layout->{0}->fulltext_image;
}

if($image !=="") {

	// Long way to count items before we get into the loop
	// must be a better way
	$count = 0;
	
	foreach ($layout as $array) {
		foreach ($array as $key => $value) {
			$count ++;
		}
	}
	
	if(!isset($options->backstretch_duration)) {
		$options->backstretch_duration = '3000';
		$options->backstretch_fade = '750';
	} 
	
	require_once $base_root . 'includes/imageresize.php'; ?>
	
	<div id="zentools-<?php echo $module->id;?>" class="backstretch-wrapper">
		<div  class="zentools zt-backstretch" style="height: <?php echo $height;?>px"></div>
		<div class="slideshow-nav-container">
			<?php if($count > 1) { ?>
		
			<div class="zentools backstretch-title">
			    <ul>
			    	<?php foreach ($list as $key => $item) { ?>
			    	    <li data-id="<?php echo $key;?>">
			    	    	<?php foreach ($columns as $column => $colwidth) { 
			    	    			$elements = $layout->$column;
			    	    			
			    	    			foreach ($elements as $type => $element) {
			    	    				$settings->count = $count;
			    	    				if($type !=="image" && $type !=="fulltext_image") { 
			    	    					$zen->loadElement($element->type, $element, $item, $settings, $zen);
			    	    				}
			    	    			}
			    	    		}?>
			    	    </li>
			    	<?php } ?>
				</ul>
			</div>
		
		<?php } ?>
		
		
		<?php if($options->navigation) { ?>
			<div id="backstretch-nav-<?php echo $module->id;?>" class="backstretch-nav">
				<a class="prev"><span class="fa fa-angle-left zen-icon zen-icon-angle-left"></span></a>
				<a class="next"><span class="fa fa-angle-right zen-icon zen-icon-angle-right"></span></a>
			</div>
		<?php } ?>
		
		<?php if($options->thumbs) { ?>
		<div id="backstretch-thumbs-<?php echo $module->id;?>" class="backstretch-thumbs">
		 <ul>
		    <?php foreach ($list as $key => $item) { 
		    	$item->image = $zen->handleRemoteImage($item->image);    
		    ?>
		        <li data-id="<?php echo $key;?>">
		        	<img src="<?php echo ZenTools2Helper::getResizedImage($item->image, $options->backstretch_thumb_width, $options->backstretch_thumb_height, $image->crop_type);?>" alt="<?php echo $item->title;?>" />
		        </li>
		    <?php } ?>
		 </ul>
		</div>
		<?php } ?>
		</div>
	</div>
	
	
	<script>
		jQuery(document).ready(function($) {
		
			$("#zentools-<?php echo $module->id;?>").backstretch([
		 		<?php foreach ($list as $key => $item) { ?>
		 			"<?php echo juri::base();?><?php echo $item->image;?>",
		 		<?php } ?>
		 	  ], {duration: <?php echo $options->backstretch_duration;?>, fade: <?php echo $options->backstretch_fade;?>});
		 	  
		 	  
		 	  // Next Previous buttons
		 	  $('#backstretch-nav-<?php echo $module->id;?> .next').click(function () {
	             $('#zentools-<?php echo $module->id;?>').backstretch("next");
	          });
	
	          $('#backstretch-nav-<?php echo $module->id;?> .prev').click(function () {
	              $('#zentools-<?php echo $module->id;?>').backstretch("prev");
	          });
	          
	          
	          $('#backstretch-thumbs-<?php echo $module->id;?> li').click(function () {
	              var slide = $(this).attr('data-id');
	              $('#zentools-<?php echo $module->id;?>').backstretch("show", slide);
	          });
	          
	           $(window).on("backstretch.before", function (e, instance, index) {
	              $(".backstretch-title li").removeClass('active');
	              $("#backstretch-thumbs-<?php echo $module->id;?> li").removeClass('active');
	              $("#backstretch-thumbs-<?php echo $module->id;?> li[data-id='" + index + "']").addClass('active');
	          });
	
	          $(window).on("backstretch.after", function (e, instance, index) {
	              $(".backstretch-title li[data-id='" + index + "']").addClass('active');
	
	          });
		});
	</script>
<?php } else { ?>
	<p class="alert alert-warning">This slideshow requires the use of images. Please add the image tag in the layout tool in your module settings.</p>
<?php } ?>

