<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 


$class = '';

// Create image element
if(isset($layout->{0}->image)) {
	$image = $layout->{0}->image;
}

// Disable / enable drag events
$mouse_drag = 1;
if(isset($options->mouse_drag)) {
	$mouse_drag = $options->mouse_drag;
}

$touch_drag = 1;
if(isset($options->touch_drag)) {
	$touch_drag = $options->touch_drag;
}

// Add a fallback if pretext_class is blank
if (!isset($options->pretext_class) || $options->pretext_class === '') {
    $options->pretext_class = 'span';
}

$layout_cols = count($columns);


if($options->pretext!=="") {
?><div id="zentools-<?php echo $module->id;?>" class="zt-ticker zt-<?php echo $options->theme;?>">
	<div  class="zt-ticker-pretext">
		<<?php echo $options->pretext_class;?>><?php echo $options->pretext;?></<?php echo $options->pretext_class;?>>
	</div>
	<?php } if($options->navigation) { 
	?><div class="zt-ticker-nav">
	  		<a class="zt-prev"><span class='fa zen-icon fa-angle-left zen-icon-angle-left'></span></a>
	  		<a class="zt-next"><span class='fa zen-icon fa-angle-right zen-icon-angle-right'></span></a>
		</div>
		<?php } 
	?><div class="zentools slideshow-<?php echo $module->id;?> owl-carousel">
		<?php foreach ($list as $key => $item) { 
		
			$item_class = '';
			if($item->featured) {
				$item_class .= ' zt-featured';
			}
			?>
			<div class="zt-item<?php echo $item_class;?> zt-item-<?php echo $key + 1;?>">
				<?php foreach ($columns as $column => $colwidth) { ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
						<?php $elements = $layout->$column;
							$count = 1;
							$total_elements = count((array)$elements);
							
							foreach ($elements as $type => $element) {
								$settings->count = $count;
								if($count == 2 && $layout_cols == 1) { ?>
									<div class="zt-item-container">
								<?php }
								
								$zen->loadElement($element->type, $element, $item, $settings, $zen);
								
								if($count == $total_elements && $count !==1 && $layout_cols == 1) { ?>
									</div>
								<?php } 
								$count ++;
							} ?>
						</div>
				<?php } ?>		
			</div>
		<?php } ?>
	</div>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<script>
	jQuery(document).ready(function($) {
	 	var sync1 = $("#zentools-<?php echo $module->id;?> .zentools");
	 	
	 	sync1.owlCarousel({
	 	   singleItem : true,
	 	   baseClass : "slideshow-<?php echo $module->id;?>",
	 	   stopOnHover: true,
	 	   slideSpeed : 1000,
	 	   stopOnHover: true,
	 	   <?php if($options->autoheight) { ?>
	 	   autoHeight: true,
	 	     <?php } ?>
	 	   <?php if(!$mouse_drag) { ?>
	 	   	mouseDrag: false,
	 	   <?php } ?>
	 	   <?php if(!$touch_drag) { ?>
	 	    	touchDrag: false,
	 	    <?php } ?>
	 	   lazyLoad : true,
	 	    pagination:false,
	 	    <?php if($options->effect !=="slide") { ?>
	 	      transitionStyle: "<?php echo $options->effect;?>",
	 	      <?php } ?>
	 	      <?php if($options->autoplay) { ?>
	 	        autoPlay : <?php echo $options->autoplay_speed;?>,
	 	        <?php } ?>
	 	    
	 	    responsiveRefreshRate : 200
	 	  });
	 	  
	 	  
	 	  
	 	  // Custom Navigation Events
	 	   $("#zentools-<?php echo $module->id;?> .zt-next").click(function(){
	 	   
	 	     sync1.trigger('owl.next');
	 	   })
	 	   $("#zentools-<?php echo $module->id;?> .zt-prev").click(function(){
	 	     sync1.trigger('owl.prev');
	 	   })
	});
</script>
